Index: /pjproject/trunk/pjsip/include/pjsip/sip_types.h
===================================================================
--- /pjproject/trunk/pjsip/include/pjsip/sip_types.h	(revision 53)
+++ /pjproject/trunk/pjsip/include/pjsip/sip_types.h	(revision 54)
@@ -26,10 +26,10 @@
  * Opaque data structure for transports (sip_transport.h).
  */
-typedef struct pjsip_transport_t pjsip_transport_t;
+typedef struct pjsip_transport pjsip_transport;
 
 /**
  * Opaque data type for transport manager (sip_transport.h).
  */
-typedef struct pjsip_transport_mgr pjsip_transport_mgr;
+typedef struct pjsip_tpmgr pjsip_tpmgr;
 
 /**
@@ -44,5 +44,4 @@
     PJSIP_TRANSPORT_UDP,
 
-#if PJ_HAS_TCP
     /** TCP. */
     PJSIP_TRANSPORT_TCP,
@@ -53,5 +52,4 @@
     /** SCTP. */
     PJSIP_TRANSPORT_SCTP,
-#endif
 
 } pjsip_transport_type_e;
Index: /pjproject/trunk/pjsip/src/pjsip-ua/sip_dialog.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip-ua/sip_dialog.c	(revision 53)
+++ /pjproject/trunk/pjsip/src/pjsip-ua/sip_dialog.c	(revision 54)
@@ -1080,4 +1080,5 @@
      * We will rewrite the message with a new status code.
      */
+    only if tdata is not pending!!!
     tdata = dlg->invite_tsx->last_tx;
     msg = tdata->msg;
Index: /pjproject/trunk/pjsip/src/pjsip/sip_auth.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip/sip_auth.c	(revision 53)
+++ /pjproject/trunk/pjsip/src/pjsip/sip_auth.c	(revision 54)
@@ -36,5 +36,5 @@
 
 /* A macro just to get rid of type mismatch between char and unsigned char */
-#define MD5_APPEND(pms,buf,len)	md5_append(pms, (const unsigned char*)buf, len)
+#define MD5_APPEND(pms,buf,len)	pj_md5_update(pms, (const pj_uint8_t*)buf, len)
 
 /* Logging. */
@@ -81,5 +81,5 @@
     char ha2[MD5STRLEN];
     unsigned char digest[16];
-    md5_state_t pms;
+    pj_md5_context pms;
 
     pj_assert(result->slen >= MD5STRLEN);
@@ -91,5 +91,5 @@
 	 *** ha1 = MD5(username ":" realm ":" password) 
 	 ***/
-	md5_init(&pms);
+	pj_md5_init(&pms);
 	MD5_APPEND( &pms, cred_info->username.ptr, cred_info->username.slen);
 	MD5_APPEND( &pms, ":", 1);
@@ -97,5 +97,5 @@
 	MD5_APPEND( &pms, ":", 1);
 	MD5_APPEND( &pms, cred_info->data.ptr, cred_info->data.slen);
-	md5_finish(&pms, digest);
+	pj_md5_final(&pms, digest);
 
 	digest2str(digest, ha1);
@@ -111,9 +111,9 @@
      *** ha2 = MD5(method ":" req_uri) 
      ***/
-    md5_init(&pms);
+    pj_md5_init(&pms);
     MD5_APPEND( &pms, method->ptr, method->slen);
     MD5_APPEND( &pms, ":", 1);
     MD5_APPEND( &pms, uri->ptr, uri->slen);
-    md5_finish(&pms, digest);
+    pj_md5_final(&pms, digest);
     digest2str(digest, ha2);
 
@@ -127,5 +127,5 @@
      ***    response = MD5(ha1 ":" nonce ":" nc ":" cnonce ":" qop ":" ha2)
      ***/
-    md5_init(&pms);
+    pj_md5_init(&pms);
     MD5_APPEND( &pms, ha1, MD5STRLEN);
     MD5_APPEND( &pms, ":", 1);
@@ -143,5 +143,5 @@
 
     /* This is the final response digest. */
-    md5_finish(&pms, digest);
+    pj_md5_final(&pms, digest);
     
     /* Convert digest to string and store in chal->response. */
@@ -735,13 +735,13 @@
     PJ_UNUSED_ARG(endpt);
 
-    pj_assert(rdata->msg->type == PJSIP_RESPONSE_MSG);
-    pj_assert(rdata->msg->line.status.code == 401 ||
-	      rdata->msg->line.status.code == 407 );
+    pj_assert(rdata->msg_info.msg->type == PJSIP_RESPONSE_MSG);
+    pj_assert(rdata->msg_info.msg->line.status.code == 401 ||
+	      rdata->msg_info.msg->line.status.code == 407 );
 
     /*
      * Respond to each authentication challenge.
      */
-    hdr = rdata->msg->hdr.next;
-    while (hdr != &rdata->msg->hdr) {
+    hdr = rdata->msg_info.msg->hdr.next;
+    while (hdr != &rdata->msg_info.msg->hdr) {
 	pjsip_auth_session *sess;
 	const pjsip_www_authenticate_hdr *hchal;
@@ -751,9 +751,9 @@
 	while (hdr->type != PJSIP_H_WWW_AUTHENTICATE &&
 	       hdr->type != PJSIP_H_PROXY_AUTHENTICATE &&
-	       hdr != &rdata->msg->hdr)
+	       hdr != &rdata->msg_info.msg->hdr)
 	{
 	    hdr = hdr->next;
 	}
-	if (hdr == &rdata->msg->hdr)
+	if (hdr == &rdata->msg_info.msg->hdr)
 	    break;
 
Index: /pjproject/trunk/pjsip/src/pjsip/sip_endpoint.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip/sip_endpoint.c	(revision 53)
+++ /pjproject/trunk/pjsip/src/pjsip/sip_endpoint.c	(revision 54)
@@ -33,5 +33,5 @@
 #include <pj/assert.h>
 #include <pj/errno.h>
-
+#include <pj/lock.h>
 
 #define PJSIP_EX_NO_MEMORY  PJ_NO_MEMORY_EXCEPTION
@@ -64,5 +64,8 @@
 
     /** Transport manager. */
-    pjsip_transport_mgr *transport_mgr;
+    pjsip_tpmgr		*transport_mgr;
+
+    /** Ioqueue. */
+    pj_ioqueue_t	*ioqueue;
 
     /** DNS Resolver. */
@@ -96,5 +99,6 @@
  * Prototypes.
  */
-static void endpt_transport_callback( pjsip_endpoint *, pjsip_rx_data *rdata );
+static void endpt_transport_callback(pjsip_endpoint*, 
+				     pj_status_t, pjsip_rx_data*);
 
 
@@ -355,4 +359,5 @@
     pjsip_endpoint *endpt;
     pjsip_max_forwards_hdr *mf_hdr;
+    pj_lock_t *lock = NULL;
 
     PJ_LOG(5, (THIS_FILE, "pjsip_endpt_create()"));
@@ -399,9 +404,26 @@
     }
 
+    /* Set recursive lock for the timer heap. */
+    status = pj_lock_create_recursive_mutex( endpt->pool, "edpt%p", &lock);
+    if (status != PJ_SUCCESS) {
+	goto on_error;
+    }
+    pj_timer_heap_set_lock(endpt->timer_heap, lock, PJ_TRUE);
+
+    /* Set maximum timed out entries to process in a single poll. */
+    pj_timer_heap_set_max_timed_out_per_poll(endpt->timer_heap, 
+					     PJSIP_MAX_TIMED_OUT_ENTRIES);
+
+    /* Create ioqueue. */
+    status = pj_ioqueue_create( endpt->pool, PJSIP_MAX_TRANSPORTS, &endpt->ioqueue);
+    if (status != PJ_SUCCESS) {
+	goto on_error;
+    }
+
     /* Create transport manager. */
-    status = pjsip_transport_mgr_create( endpt->pool,
-					 endpt,
-					 &endpt_transport_callback,
-					 &endpt->transport_mgr);
+    status = pjsip_tpmgr_create( endpt->pool, endpt,
+				 endpt->ioqueue, endpt->timer_heap,
+			         &endpt_transport_callback,
+				 &endpt->transport_mgr);
     if (status != PJ_SUCCESS) {
 	goto on_error;
@@ -446,5 +468,5 @@
 on_error:
     if (endpt->transport_mgr) {
-	pjsip_transport_mgr_destroy(endpt->transport_mgr);
+	pjsip_tpmgr_destroy(endpt->transport_mgr);
 	endpt->transport_mgr = NULL;
     }
@@ -471,5 +493,5 @@
 
     /* Shutdown and destroy all transports. */
-    pjsip_transport_mgr_destroy(endpt->transport_mgr);
+    pjsip_tpmgr_destroy(endpt->transport_mgr);
 
     /* Delete endpoint mutex. */
@@ -533,18 +555,14 @@
 					const pj_time_val *max_timeout)
 {
-    pj_time_val timeout;
-    int i;
+    /* timeout is 'out' var. This just to make compiler happy. */
+    pj_time_val timeout = { 0, 0};
 
     PJ_LOG(5, (THIS_FILE, "pjsip_endpt_handle_events()"));
 
     /* Poll the timer. The timer heap has its own mutex for better 
-     * granularity, so we don't need to lock end endpoint. We also keep
-     * polling the timer while we have events.
+     * granularity, so we don't need to lock end endpoint. 
      */
-    timeout.sec = timeout.msec = 0; /* timeout is 'out' var. This just to make compiler happy. */
-    for (i=0; i<10; ++i) {
-	if (pj_timer_heap_poll( endpt->timer_heap, &timeout ) < 1)
-	    break;
-    }
+    timeout.sec = timeout.msec = 0;
+    pj_timer_heap_poll( endpt->timer_heap, &timeout );
 
     /* If caller specifies maximum time to wait, then compare the value with
@@ -555,6 +573,6 @@
     }
 
-    /* Poll events in the transport manager. */
-    pjsip_transport_mgr_handle_events( endpt->transport_mgr, &timeout);
+    /* Poll ioqueue. */
+    pj_ioqueue_poll( endpt->ioqueue, &timeout);
 }
 
@@ -659,11 +677,11 @@
 {
     pjsip_role_e role;
-    if (rdata->msg->type == PJSIP_REQUEST_MSG) {
+    if (rdata->msg_info.msg->type == PJSIP_REQUEST_MSG) {
 	role = PJSIP_ROLE_UAS;
     } else {
 	role = PJSIP_ROLE_UAC;
     }
-    pjsip_tsx_create_key(rdata->pool, &rdata->key, role,
-			 &rdata->cseq->method, rdata);
+    pjsip_tsx_create_key(rdata->tp_info.pool, &rdata->endpt_info.key, role,
+			 &rdata->msg_info.cseq->method, rdata);
 }
 
@@ -673,11 +691,23 @@
  */
 static void endpt_transport_callback( pjsip_endpoint *endpt,
+				      pj_status_t status,
 				      pjsip_rx_data *rdata )
 {
-    pjsip_msg *msg = rdata->msg;
+    pjsip_msg *msg = rdata->msg_info.msg;
     pjsip_transaction *tsx;
     pj_bool_t a_new_transaction_just_been_created = PJ_FALSE;
 
     PJ_LOG(5, (THIS_FILE, "endpt_transport_callback(rdata=%p)", rdata));
+
+    if (status != PJ_SUCCESS) {
+	const char *src_addr = pj_inet_ntoa(rdata->pkt_info.addr.sin_addr);
+	int port = pj_ntohs(rdata->pkt_info.addr.sin_port);
+	PJSIP_ENDPT_LOG_ERROR((endpt, "transport", status,
+			       "Src.addr=%s:%d, packet:--\n"
+			       "%s\n"
+			       "-- end of packet. Error",
+			       src_addr, port, rdata->msg_info.msg_buf));
+	return;
+    }
 
     /* For response, check that the value in Via sent-by match the transport.
@@ -688,14 +718,14 @@
 	const pj_sockaddr_in *addr;
 	const char *addr_addr;
-	int port = rdata->via->sent_by.port;
+	int port = rdata->msg_info.via->sent_by.port;
 	pj_bool_t mismatch = PJ_FALSE;
 	if (port == 0) {
 	    int type;
-	    type = pjsip_transport_get_type(rdata->transport);
+	    type = rdata->tp_info.transport->type;
 	    port = pjsip_transport_get_default_port_for_type(type);
 	}
-	addr = pjsip_transport_get_addr_name(rdata->transport);
+	addr = &rdata->tp_info.transport->public_addr;
 	addr_addr = pj_inet_ntoa(addr->sin_addr);
-	if (pj_strcmp2(&rdata->via->sent_by.host, addr_addr) != 0)
+	if (pj_strcmp2(&rdata->msg_info.via->sent_by.host, addr_addr) != 0)
 	    mismatch = PJ_TRUE;
 	else if (port != pj_ntohs(addr->sin_port)) {
@@ -707,5 +737,5 @@
 	     * both the port in sent-by and rport. We try to be lenient here!
 	     */
-	    if (rdata->via->rport_param != pj_sockaddr_in_get_port(addr))
+	    if (rdata->msg_info.via->rport_param != pj_sockaddr_in_get_port(addr))
 		mismatch = PJ_TRUE;
 	    else {
@@ -730,5 +760,5 @@
     /* Find the transaction for the received message. */
     PJ_LOG(5, (THIS_FILE, "finding tsx with key=%.*s", 
-			 rdata->key.slen, rdata->key.ptr));
+			 rdata->endpt_info.key.slen, rdata->endpt_info.key.ptr));
 
     /* Start lock mutex in the endpoint. */
@@ -736,5 +766,5 @@
 
     /* Find the transaction in the hash table. */
-    tsx = pj_hash_get( endpt->tsx_table, rdata->key.ptr, rdata->key.slen );
+    tsx = pj_hash_get( endpt->tsx_table, rdata->endpt_info.key.ptr, rdata->endpt_info.key.slen );
 
     /* Unlock mutex. */
@@ -753,5 +783,5 @@
 	    /* Inform TU about the 200 message, only if it's INVITE. */
 	    if (PJSIP_IS_STATUS_IN_CLASS(msg->line.status.code, 200) &&
-		rdata->cseq->method.id == PJSIP_INVITE_METHOD) 
+		rdata->msg_info.cseq->method.id == PJSIP_INVITE_METHOD) 
 	    {
 		pjsip_event e;
@@ -777,5 +807,5 @@
 	 * For non-ACK request message, create a new transaction.
 	 */
-	} else if (rdata->msg->line.req.method.id != PJSIP_ACK_METHOD) {
+	} else if (rdata->msg_info.msg->line.req.method.id != PJSIP_ACK_METHOD) {
 
 	    pj_status_t status;
@@ -806,5 +836,5 @@
 	pjsip_tsx_on_rx_msg( tsx, rdata );
 
-    } else if (rdata->msg->line.req.method.id == PJSIP_ACK_METHOD) {
+    } else if (rdata->msg_info.msg->line.req.method.id == PJSIP_ACK_METHOD) {
 	/*
 	 * This is an ACK message, but the INVITE transaction could not
@@ -915,33 +945,14 @@
  * Find/create transport.
  */
-PJ_DEF(void) pjsip_endpt_get_transport( pjsip_endpoint *endpt,
-					pj_pool_t *pool,
-					pjsip_transport_type_e type,
-					const pj_sockaddr_in *remote,
-					void *token,
-					pjsip_transport_completion_callback *cb)
-{
-    PJ_LOG(5, (THIS_FILE, "pjsip_endpt_get_transport()"));
-    pjsip_transport_get( endpt->transport_mgr, pool, type,
-			 remote, token, cb);
-}
-
-
-PJ_DEF(pj_status_t) pjsip_endpt_create_listener( pjsip_endpoint *endpt,
-						 pjsip_transport_type_e type,
-						 pj_sockaddr_in *addr,
-						 const pj_sockaddr_in *addr_name)
-{
-    PJ_LOG(5, (THIS_FILE, "pjsip_endpt_create_listener()"));
-    return pjsip_create_listener( endpt->transport_mgr, type, addr, addr_name );
-}
-
-PJ_DEF(pj_status_t) pjsip_endpt_create_udp_listener( pjsip_endpoint *endpt,
-						     pj_sock_t sock,
-						     const pj_sockaddr_in *addr_name)
-{
-    PJ_LOG(5, (THIS_FILE, "pjsip_endpt_create_udp_listener()"));
-    return pjsip_create_udp_listener( endpt->transport_mgr, sock, addr_name );
-}
+PJ_DECL(pj_status_t) pjsip_endpt_alloc_transport( pjsip_endpoint *endpt,
+						  pjsip_transport_type_e type,
+						  const pj_sockaddr_in *remote,
+						  pjsip_transport **p_transport)
+{
+    PJ_LOG(5, (THIS_FILE, "pjsip_endpt_alloc_transport()"));
+    return pjsip_tpmgr_alloc_transport( endpt->transport_mgr, type, remote,
+					p_transport);
+}
+
 
 PJ_DEF(void) pjsip_endpt_dump( pjsip_endpoint *endpt, pj_bool_t detail )
@@ -949,6 +960,4 @@
 #if PJ_LOG_MAX_LEVEL >= 3
     unsigned count;
-    pj_hash_iterator_t itr_val;
-    pj_hash_iterator_t *itr;
 
     PJ_LOG(5, (THIS_FILE, "pjsip_endpt_dump()"));
@@ -1015,36 +1024,6 @@
 
     /* Transports. 
-     * Note: transport is not properly locked in this function.
-     *       See pjsip_transport_first, pjsip_transport_next.
      */
-    itr = pjsip_transport_first( endpt->transport_mgr, &itr_val );
-    if (itr) {
-	PJ_LOG(3, (THIS_FILE, " Dumping transports:"));
-
-	do {
-	    char src_addr[128], dst_addr[128];
-	    int src_port, dst_port;
-	    const pj_sockaddr_in *addr;
-	    pjsip_transport_t *t;
-
-	    t = pjsip_transport_this(endpt->transport_mgr, itr);
-	    addr = pjsip_transport_get_local_addr(t);
-	    pj_native_strcpy(src_addr, pj_inet_ntoa(addr->sin_addr));
-	    src_port = pj_ntohs(addr->sin_port);
-
-	    addr = pjsip_transport_get_remote_addr(t);
-	    pj_native_strcpy(dst_addr, pj_inet_ntoa(addr->sin_addr));
-	    dst_port = pj_ntohs(addr->sin_port);
-
-	    PJ_LOG(3, (THIS_FILE, "  %s %s %s:%d --> %s:%d (refcnt=%d)", 
-		       pjsip_transport_get_type_name(t),
-		       pjsip_transport_get_obj_name(t),
-		       src_addr, src_port,
-		       dst_addr, dst_port,
-		       pjsip_transport_get_ref_cnt(t)));
-
-	    itr = pjsip_transport_next(endpt->transport_mgr, itr);
-	} while (itr);
-    }
+    pjsip_tpmgr_dump_transports( endpt->transport_mgr );
 
     /* Timer. */
Index: /pjproject/trunk/pjsip/src/pjsip/sip_misc.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip/sip_misc.c	(revision 53)
+++ /pjproject/trunk/pjsip/src/pjsip/sip_misc.c	(revision 54)
@@ -430,5 +430,5 @@
 
     /* rdata must be a request message. */
-    req_msg = rdata->msg;
+    req_msg = rdata->msg_info.msg;
     pj_assert(req_msg->type == PJSIP_REQUEST_MSG);
 
@@ -450,8 +450,8 @@
 
     /* Set TX data attributes. */
-    tdata->rx_timestamp = rdata->timestamp;
+    tdata->rx_timestamp = rdata->pkt_info.timestamp;
 
     /* Copy all the via headers, in order. */
-    via = rdata->via;
+    via = rdata->msg_info.via;
     while (via) {
 	pjsip_msg_add_hdr( msg, pjsip_hdr_clone(tdata->pool, via));
@@ -479,13 +479,13 @@
 
     /* Copy From header. */
-    hdr = pjsip_hdr_clone(tdata->pool, rdata->from);
+    hdr = pjsip_hdr_clone(tdata->pool, rdata->msg_info.from);
     pjsip_msg_add_hdr( msg, hdr);
 
     /* Copy To header. */
-    hdr = pjsip_hdr_clone(tdata->pool, rdata->to);
+    hdr = pjsip_hdr_clone(tdata->pool, rdata->msg_info.to);
     pjsip_msg_add_hdr( msg, hdr);
 
     /* Copy CSeq header. */
-    hdr = pjsip_hdr_clone(tdata->pool, rdata->cseq);
+    hdr = pjsip_hdr_clone(tdata->pool, rdata->msg_info.cseq);
     pjsip_msg_add_hdr( msg, hdr);
 
@@ -515,6 +515,6 @@
 
     /* rdata must be a final response. */
-    pj_assert(rdata->msg->type==PJSIP_RESPONSE_MSG &&
-	      rdata->msg->line.status.code >= 300);
+    pj_assert(rdata->msg_info.msg->type==PJSIP_RESPONSE_MSG &&
+	      rdata->msg_info.msg->line.status.code >= 300);
 
     /* Log this action. */
@@ -543,5 +543,5 @@
     to = (pjsip_to_hdr*)pjsip_msg_find_remove_hdr( invite_msg, 
 						   PJSIP_H_TO, NULL);
-    pj_strdup(tdata->pool, &to->tag, &rdata->to->tag);
+    pj_strdup(tdata->pool, &to->tag, &rdata->msg_info.to->tag);
     pjsip_msg_add_hdr( ack_msg, (pjsip_hdr*)to );
 
@@ -675,5 +675,5 @@
  */
 PJ_DEF(pj_status_t) pjsip_get_response_addr(pj_pool_t *pool,
-					    const pjsip_transport_t *req_transport,
+					    const pjsip_transport *req_transport,
 					    const pjsip_via_hdr *via,
 					    pjsip_host_port *send_addr)
@@ -688,10 +688,10 @@
      * - otherwise send to the address in sent-by.
      */
-    send_addr->flag = pjsip_transport_get_flag(req_transport);
-    send_addr->type = pjsip_transport_get_type(req_transport);
+    send_addr->flag = req_transport->flag;
+    send_addr->type = req_transport->type;
 
     if (PJSIP_TRANSPORT_IS_RELIABLE(req_transport)) {
 	const pj_sockaddr_in *remote_addr;
-	remote_addr = pjsip_transport_get_remote_addr(req_transport);
+	remote_addr = &req_transport->rem_addr;
 	pj_strdup2(pool, &send_addr->host, 
 		   pj_inet_ntoa(remote_addr->sin_addr));
Index: /pjproject/trunk/pjsip/src/pjsip/sip_parser.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip/sip_parser.c	(revision 53)
+++ /pjproject/trunk/pjsip/src/pjsip/sip_parser.c	(revision 54)
@@ -559,17 +559,17 @@
 
     context.scanner = &scanner;
-    context.pool = rdata->pool;
+    context.pool = rdata->tp_info.pool;
     context.rdata = rdata;
 
     PJ_TRY {
-	rdata->msg = int_parse_msg(&context, &rdata->parse_err);
+	rdata->msg_info.msg = int_parse_msg(&context, &rdata->msg_info.parse_err);
     } 
     PJ_DEFAULT {
-	rdata->msg = NULL;
+	rdata->msg_info.msg = NULL;
     }
     PJ_END
 
     pj_scan_fini(&scanner);
-    return rdata->msg;
+    return rdata->msg_info.msg;
 }
 
@@ -1259,5 +1259,5 @@
 
     if (ctx->rdata)
-        ctx->rdata->call_id = hdr->id;
+        ctx->rdata->msg_info.call_id = hdr->id;
 
     return (pjsip_hdr*)hdr;
@@ -1340,5 +1340,5 @@
 
     if (ctx->rdata)
-        ctx->rdata->clen = hdr;
+        ctx->rdata->msg_info.clen = hdr;
 
     return (pjsip_hdr*)hdr;
@@ -1368,5 +1368,5 @@
 
     if (ctx->rdata)
-        ctx->rdata->ctype = hdr;
+        ctx->rdata->msg_info.ctype = hdr;
 
     return (pjsip_hdr*)hdr;
@@ -1389,5 +1389,5 @@
 
     if (ctx->rdata)
-        ctx->rdata->cseq = hdr;
+        ctx->rdata->msg_info.cseq = hdr;
 
     return (pjsip_hdr*)hdr;
@@ -1433,5 +1433,5 @@
     parse_hdr_fromto(ctx->scanner, ctx->pool, hdr);
     if (ctx->rdata)
-        ctx->rdata->from = hdr;
+        ctx->rdata->msg_info.from = hdr;
 
     return (pjsip_hdr*)hdr;
@@ -1444,6 +1444,6 @@
     parse_generic_array_hdr(hdr, ctx->scanner);
 
-    if (ctx->rdata && ctx->rdata->require == NULL)
-        ctx->rdata->require = hdr;
+    if (ctx->rdata && ctx->rdata->msg_info.require == NULL)
+        ctx->rdata->msg_info.require = hdr;
 
     return (pjsip_hdr*)hdr;
@@ -1475,5 +1475,5 @@
 
     if (ctx->rdata)
-        ctx->rdata->to = hdr;
+        ctx->rdata->msg_info.to = hdr;
 
     return (pjsip_hdr*)hdr;
@@ -1529,5 +1529,5 @@
 
     if (ctx->rdata)
-        ctx->rdata->max_fwd = hdr;
+        ctx->rdata->msg_info.max_fwd = hdr;
 
     return (pjsip_hdr*)hdr;
@@ -1579,6 +1579,6 @@
     parse_hdr_end(scanner);
 
-    if (ctx->rdata && ctx->rdata->record_route==NULL)
-        ctx->rdata->record_route = first;
+    if (ctx->rdata && ctx->rdata->msg_info.record_route==NULL)
+        ctx->rdata->msg_info.record_route = first;
 
     return (pjsip_hdr*)first;
@@ -1607,6 +1607,6 @@
     parse_hdr_end(scanner);
 
-    if (ctx->rdata && ctx->rdata->route==NULL)
-        ctx->rdata->route = first;
+    if (ctx->rdata && ctx->rdata->msg_info.route==NULL)
+        ctx->rdata->msg_info.route = first;
 
     return (pjsip_hdr*)first;
@@ -1660,6 +1660,6 @@
     parse_hdr_end(scanner);
 
-    if (ctx->rdata && ctx->rdata->via == NULL)
-        ctx->rdata->via = first;
+    if (ctx->rdata && ctx->rdata->msg_info.via == NULL)
+        ctx->rdata->msg_info.via = first;
 
     return (pjsip_hdr*)first;
Index: /pjproject/trunk/pjsip/src/pjsip/sip_transaction.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip/sip_transaction.c	(revision 53)
+++ /pjproject/trunk/pjsip/src/pjsip/sip_transaction.c	(revision 54)
@@ -193,16 +193,16 @@
 
     PJ_ASSERT_RETURN(pool && str && method && rdata, PJ_EINVAL);
-    PJ_ASSERT_RETURN(rdata->msg, PJ_EINVAL);
-    PJ_ASSERT_RETURN(rdata->via, PJSIP_EMISSINGHDR);
-    PJ_ASSERT_RETURN(rdata->cseq, PJSIP_EMISSINGHDR);
-    PJ_ASSERT_RETURN(rdata->from, PJSIP_EMISSINGHDR);
-
-    host = &rdata->via->sent_by.host;
-    req_uri = (pjsip_uri*)rdata->msg->line.req.uri;
+    PJ_ASSERT_RETURN(rdata->msg_info.msg, PJ_EINVAL);
+    PJ_ASSERT_RETURN(rdata->msg_info.via, PJSIP_EMISSINGHDR);
+    PJ_ASSERT_RETURN(rdata->msg_info.cseq, PJSIP_EMISSINGHDR);
+    PJ_ASSERT_RETURN(rdata->msg_info.from, PJSIP_EMISSINGHDR);
+
+    host = &rdata->msg_info.via->sent_by.host;
+    req_uri = (pjsip_uri*)rdata->msg_info.msg->line.req.uri;
 
     /* Calculate length required. */
     len_required = 9 +			    /* CSeq number */
-		   rdata->from->tag.slen +   /* From tag. */
-		   rdata->call_id.slen +    /* Call-ID */
+		   rdata->msg_info.from->tag.slen +   /* From tag. */
+		   rdata->msg_info.call_id.slen +    /* Call-ID */
 		   host->slen +		    /* Via host. */
 		   9 +			    /* Via port. */
@@ -232,17 +232,17 @@
 
     /* Add CSeq (only the number). */
-    len = pj_utoa(rdata->cseq->cseq, p);
+    len = pj_utoa(rdata->msg_info.cseq->cseq, p);
     p += len;
     *p++ = SEPARATOR;
 
     /* Add From tag. */
-    len = rdata->from->tag.slen;
-    pj_memcpy( p, rdata->from->tag.ptr, len);
+    len = rdata->msg_info.from->tag.slen;
+    pj_memcpy( p, rdata->msg_info.from->tag.ptr, len);
     p += len;
     *p++ = SEPARATOR;
 
     /* Add Call-ID. */
-    len = rdata->call_id.slen;
-    pj_memcpy( p, rdata->call_id.ptr, len );
+    len = rdata->msg_info.call_id.slen;
+    pj_memcpy( p, rdata->msg_info.call_id.ptr, len );
     p += len;
     *p++ = SEPARATOR;
@@ -258,5 +258,5 @@
     *p++ = ':';
 
-    len = pj_utoa(rdata->via->sent_by.port, p);
+    len = pj_utoa(rdata->msg_info.via->sent_by.port, p);
     p += len;
     *p++ = SEPARATOR;
@@ -325,5 +325,5 @@
      * handled as RFC2543.
      */
-    const pj_str_t *branch = &rdata->via->branch_param;
+    const pj_str_t *branch = &rdata->msg_info.via->branch_param;
 
     if (pj_strncmp(branch,&rfc3261_branch,PJSIP_RFC3261_BRANCH_LEN)==0) {
@@ -643,5 +643,5 @@
  * has completed, with or without error.
  */
-static void tsx_transport_callback(pjsip_transport_t *tr, 
+static void tsx_transport_callback(pjsip_transport *tr, 
 				   void *token, 
 				   pj_status_t status)
@@ -657,9 +657,9 @@
     if (status == PJ_SUCCESS) {
 	PJ_LOG(4, (tsx->obj_name, "%s connected to %s:%d",
-				  pjsip_transport_get_type_name(tr),
+				  tr->type_name,
 				  addr, tsx->dest_name.port));
     } else {
 	PJ_LOG(4, (tsx->obj_name, "%s unable to connect to %s:%d, status=%d", 
-				  pjsip_transport_get_type_name(tr),
+				  tr->type_name,
 				  addr, tsx->dest_name.port, status));
     }
@@ -878,5 +878,5 @@
 					pjsip_rx_data *rdata)
 {
-    pjsip_msg *msg = rdata->msg;
+    pjsip_msg *msg = rdata->msg_info.msg;
     pj_str_t *branch;
     pjsip_cseq_hdr *cseq;
@@ -890,5 +890,5 @@
 
     /* Keep shortcut to message */
-    msg = rdata->msg;
+    msg = rdata->msg_info.msg;
 
     /* Role is UAS */
@@ -909,5 +909,5 @@
 
     /* Duplicate branch parameter for transaction. */
-    branch = &rdata->via->branch_param;
+    branch = &rdata->msg_info.via->branch_param;
     pj_strdup(tsx->pool, &tsx->branch, branch);
 
@@ -916,5 +916,5 @@
 
     /* Save CSeq */
-    cseq = rdata->cseq;
+    cseq = rdata->msg_info.cseq;
     tsx->cseq = cseq->cseq;
 
@@ -932,8 +932,8 @@
      * then return the response using the same transport.
      */
-    if (PJSIP_TRANSPORT_IS_RELIABLE(rdata->transport) || 
-	rdata->via->rport_param >= 0) 
+    if (PJSIP_TRANSPORT_IS_RELIABLE(rdata->tp_info.transport) || 
+	rdata->msg_info.via->rport_param >= 0) 
     {
-	tsx->transport = rdata->transport;
+	tsx->transport = rdata->tp_info.transport;
 	pjsip_transport_add_ref(tsx->transport);
 	tsx->transport_state = PJSIP_TSX_TRANSPORT_STATE_FINAL;
@@ -944,11 +944,11 @@
 		pjsip_transport_get_type(tsx->transport);
 	pj_memcpy(&tsx->remote_addr.entry[0].addr, 
-		  &rdata->addr, rdata->addr_len);
+		  &rdata->pkt_info.addr, rdata->pkt_info.addr_len);
 	
     } else {
 	pj_status_t status;
 
-	status = pjsip_get_response_addr(tsx->pool, rdata->transport,
-					 rdata->via, &tsx->dest_name);
+	status = pjsip_get_response_addr(tsx->pool, rdata->tp_info.transport,
+					 rdata->msg_info.via, &tsx->dest_name);
 	if (status != PJ_SUCCESS) {
 	    tsx->transport_state = PJSIP_TSX_TRANSPORT_STATE_FINAL;
@@ -1213,7 +1213,7 @@
 	    /* Don't update Via sent-by on retransmission. */
 	    if (via->sent_by.host.slen == 0) {
-		addr_name = pjsip_transport_get_addr_name(tsx->transport);
+		addr_name = &tsx->transport->public_addr;
 		pj_strdup2(tdata->pool, &via->transport, 
-			pjsip_transport_get_type_name(tsx->transport));
+			   tsx->transport->type_name);
 		pj_strdup2(tdata->pool, &via->sent_by.host, 
 			   pj_inet_ntoa(addr_name->sin_addr));
@@ -1397,5 +1397,5 @@
 	 */
 	/* Keep last_tx for authorization. */
-	code = event->body.rx_msg.rdata->msg->line.status.code;
+	code = event->body.rx_msg.rdata->msg_info.msg->line.status.code;
 	if (tsx->method.id != PJSIP_INVITE_METHOD && code!=401 && code!=407) {
 	    pjsip_tx_data_dec_ref(tsx->last_tx);
@@ -1666,5 +1666,5 @@
 	}
 
-	tsx->status_code = event->body.rx_msg.rdata->msg->line.status.code;
+	tsx->status_code = event->body.rx_msg.rdata->msg_info.msg->line.status.code;
     } else {
 	tsx->status_code = PJSIP_SC_TSX_TIMEOUT;
@@ -1763,5 +1763,5 @@
 
     if (event->type == PJSIP_EVENT_RX_MSG) {
-	pjsip_msg *msg = event->body.rx_msg.rdata->msg;
+	pjsip_msg *msg = event->body.rx_msg.rdata->msg_info.msg;
 	pjsip_cseq_hdr *cseq = pjsip_msg_find_hdr( msg, PJSIP_H_CSEQ, NULL );
 
@@ -1856,5 +1856,5 @@
 	     * TU doesn't need to be informed.
 	     */
-	    pjsip_msg *msg = event->body.rx_msg.rdata->msg;
+	    pjsip_msg *msg = event->body.rx_msg.rdata->msg_info.msg;
 	    pj_assert(msg->type == PJSIP_RESPONSE_MSG);
 	    if (msg->type==PJSIP_RESPONSE_MSG &&
@@ -1922,8 +1922,8 @@
 
         pjsip_method_e method_id = 
-            event->body.rx_msg.rdata->msg->line.req.method.id;
+            event->body.rx_msg.rdata->msg_info.msg->line.req.method.id;
 
 	/* Must be a request message. */
-	pj_assert(event->body.rx_msg.rdata->msg->type == PJSIP_REQUEST_MSG);
+	pj_assert(event->body.rx_msg.rdata->msg_info.msg->type == PJSIP_REQUEST_MSG);
 
 	/* Must be an ACK request or a late INVITE retransmission. */
